#ifndef _T_BOUNDS_EXCEPTION_HH
#define _T_BOUNDS_EXCEPTION_HH

#include "TException.hh"

/**
 * Exception thrown on out of bounds conditions.
 * For example when trying to insert a value at position ten in a list
 * that only has five elements.
 *
 * @author Johan Bolmsjo <johan@nocrew.org>
 */

class TBoundsException : public TException
{
public:
  
  /**
   * Construct exception with default message.
   */
  TBoundsException ();
  
  /**
   * Construct exception with custom message.
   */
  TBoundsException (const TString& str) : TException (str) { }  
};

#endif // _T_BOUNDS_EXCEPTION_HH
