#include "universe.h"
#ifdef HAVE_POSTGRESQL

#include "TDBConnectionManager.hh"

/* Static members. */
TString TDBConnectionManager::myUsername;
TString TDBConnectionManager::myPassword;
TString TDBConnectionManager::myDatabase;
TString TDBConnectionManager::myHost;
TString TDBConnectionManager::myPort;

TDBConnection* TDBConnectionManager::myConn = 0;


void
TDBConnectionManager::SetLogin (TString username,
				TString password,
				TString database,
				TString host,
				TString port)
{
  myUsername = username;
  myPassword = password;
  myDatabase = database;
  myHost = host;
  myPort = port;
}


TDBConnection*
TDBConnectionManager::Connection (int index)
{
  if (! myConn)
    myConn = new TDBConnection ();
  
  if (! myConn->IsValid ())
    myConn->Open (myUsername, myPassword, myDatabase, myHost, myPort);
  
  return myConn;
}


void
TDBConnectionManager::Close ()
{
  if (myConn)
    {
      delete myConn;
      myConn = 0;
    }
}

#endif //HAVE_POSTGRESQL
