#ifndef _T_EXCEPTION_HH
#define _T_EXCEPTION_HH

#include "TString.hh"

/**
 * Base class for exceptions thrown by T* classes.
 *
 * @author Johan Bolmsjo <johan@nocrew.org>
 */

class TException
{
public:
  
  /**
   * Construct exception without message.
   */
  TException () { }
  
  /**
   * Construct exception with custom message.
   */
  TException (const TString& str) : message (str) { }
  
  /**
   * Print error message to stderr.
   */
  void Print ();
  
  /**
   * Error message.
   */
  TString message;
};

#endif // _T_EXCEPTION_HH
