#ifndef _T_HASH_T_HH
#define _T_HASH_T_HH

#include "TUtil.hh"

/**
 * Template class to use arbitary objects as keys with the TValHashMapT
 * and TValHashSetT classes.
 *
 * @see THashInt
 * @see THashString
 *
 * @author Johan Bolmsjo <johan@nocrew.org>
 */

template <class T>
class THashT
{
public:
  
  //! Hash type
  static inline unsigned int Hash (const T& x)
  {
    return (TUtil::Hash ((char *)&x, sizeof (x)));
  }
  
  //! Compare two types
  static inline bool Equal (const T& x, const T& y)
  {
    return (x == y);
  }
};

#endif // _T_HASH_T_HH
