#include "TUtil.hh"

// Modified version from TCL -- tclHash.c
unsigned int
TUtil::Hash (const char *cs, int n, unsigned int hash)
{
  int i, j = n & ~3;
  
  for (i = 0; i < j; i += 4)
    {
      hash += (hash << 3) + (unsigned int)((const unsigned char *)cs)[i];
      hash += (hash << 3) + (unsigned int)((const unsigned char *)cs)[i + 1];
      hash += (hash << 3) + (unsigned int)((const unsigned char *)cs)[i + 2];
      hash += (hash << 3) + (unsigned int)((const unsigned char *)cs)[i + 3];
    }
  
  for (; i < n; i++)
    hash += (hash << 3) + (unsigned int)((const unsigned char *)cs)[i];
  
  return hash;
}


bool
TUtil::Equal (const char *s1, const char *s2, int n)
{
  int i, j = n & ~3;
  
  for (i = 0; i < j; i += 4)
    {
      if (s1[i] != s2[i])
	goto not_equal;
      if (s1[i + 1] != s2[i + 1])
	goto not_equal;
      if (s1[i + 2] != s2[i + 2])
	goto not_equal;
      if (s1[i + 3] != s2[i + 3])
	goto not_equal;
    }
  
  for (; i < n; i++)
    {
      if (s1[i] != s2[i])
	goto not_equal;
    }
  
  return true;
  
 not_equal:
  return false;
}


void
TUtil::CopyOverlapped (char *s1, const char *s2, int n)
{
  int i;

  if (s1 <= s2)
    {
      int j = n & ~3;
      
      for (i = 0; i < j; i += 4)
	{
	  s1[i] = s2[i];
	  s1[i + 1] = s2[i + 1];
	  s1[i + 2] = s2[i + 2];
	  s1[i + 3] = s2[i + 3];
	}
      
      for (; i < n; i++)
	s1[i] = s2[i];
    }
  else
    {
      for (i = n - 1; i >= 3; i -= 4)
	{
	  s1[i] = s2[i];
	  s1[i - 1] = s2[i - 1];
	  s1[i - 2] = s2[i - 2];
	  s1[i - 3] = s2[i - 3];
	}
      
      for (; i >= 0; i--)
	s1[i] = s2[i];
    }
}
