#ifndef _T_UTIL_HH
#define _T_UTIL_HH

// Simple utility functions used by the library.

class TUtil
{
public:
  
  /**
   * Hash function.
   *
   * @param cs    Ptr to start of data.
   * @param n     Length of data.
   * @param hash  Previous hash value to continue from (if any).
   * @return      Hash value
   */
  static unsigned int Hash (const char *cs, int n,
			    unsigned int hash = 0);
  
  /**
   * Fast memcmp routine, only compares if equal of not.
   *
   * @param s1  Memory area 1.
   * @param s2  Memory area 2.
   * @param n   Number of bytes to compare.
   * @retuen    true, equla or false, not equal.
   */
  static bool Equal (const char *s1, const char *s2, int n);
  
  /**
   * Memory copy routine for possible overlapped data.
   * FIXME: Not used at the moment!
   *
   * @param s1  Memory area 1.
   */
  static void CopyOverlapped (char *s1, const char *s2, int n);
};

#endif // _T_UTIL_HH
