/**
 * Program that prints the CFLAGS and LIBS variables needed to build
 * something with the Tools library.
 *
 * Usage: tools-config [--cflags] [--libs]
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "TString.hh"


int
main (int argc, char **argv)
{
  TString cflags (TOOLS_CFLAGS);
  TString libs (TOOLS_LIBS);
  TString key_cflags ("--cflags"), key_libs ("--libs"), result;
  
  if (argc == 1)
    {
      printf ("usage: tools-config [--cflags] [--libs]\n");
      exit (1);
    }
  
  for (int i = 1; i < argc; i++)
    {
      if (key_cflags == argv[i])
	cflags.Print ();
      else if (key_libs == argv[i])
	libs.Print ();
    }
  
  return 0;
}
