#include "Timer.hh"


Timer::Timer ()
  : myBogoMips (1)
{
  unsigned long ticks, loops = 1;
  
  printf ("Calculating BogoMIPS\n");
  
  while ((loops <<= 1))
    {
      ticks = clock ();
      Delay (loops);
      ticks = clock() - ticks;
      if (ticks >= (CLOCKS_PER_SEC / 5))
	{
	  myBogoMips = ((loops / ticks) * CLOCKS_PER_SEC) / 1000000;
	  break;
	}
    }
  
  printf ("%lu\n", myBogoMips);
}


void
Timer::LoopsPerSec (int loops)
{
  loops = (long long) loops * CLOCKS_PER_SEC / (clock () - myTicks);
  printf ("%d\n", loops);
}


void
Timer::Delay (int loops)
{
  for (int i = loops; i >= 0 ; i--)
    ;
}
