/**
 * Time measurement.
 * Used in the Tools benchmark suite.
 */

#include <stdio.h>
#include <time.h>


class Timer
{
public:
  
  Timer ();
  
  /**
   * Reset timer.
   */
  void Reset () { myTicks = clock (); }
  
  /**
   * Get number of bogo mips.
   */
  int BogoMips () { return myBogoMips; }
  
  /**
   * Print number of loops per second since last call to Reset().
   *
   * @param loops  The number of loops to use in the calculation.
   */
  void LoopsPerSec (int loops);
  
  
private:
  
  /**
   * Simple delay loop.
   */
  void Delay (int loops);
  
  
  /* Bogo Mips */
  unsigned long myBogoMips;
  
  /* Ticks between Start() and Stop(). */
  clock_t myTicks;
};
