#include <stdio.h>
#include "TString.hh"
#include "THashInt.hh"
#include "THashString.hh"
#include "THashT.hh"
#include "TValHashMapT.hh"


void
apply_func1 (const int *k, int *v, void *d)
{
  *v = (int)d;
}


void
apply_func2 (const int *k, int *v, void *d)
{
  printf ("key: %d  value: %d\n", *k, *v);
}


int
main ()
{
  TValHashMapT<int,int,THashInt> map1;
  TValHashMapT<int,int,THashInt> map2;
  TValHashMapT<TString,int,THashString> map3;
  int value;
  
  for (int i = 0; i < 8; i++)
    map1.Insert (i, i % 3 + 100);
  
  map2 = map1;
  
  map1.Apply (apply_func1, (void *)42);
  
  map1[7] = 22;
  map1[8] = 23;
  
  if (map2.FindValue (0, value))
    printf ("Value: %d\n", value);
  
  map1.Apply (apply_func2, (void *)42);
  printf ("--\n");
  map2.Apply (apply_func2, (void *)42);
  
  map3.Insert ("kalle", 32);
  map3["kalle"] = 44;
  printf ("%d\n", map3["kalle"]);
  
  return 0;
}
